#!/usr/bin/python

import Tkinter as tk
import tkFont
import time
import math

# Redraw AI 
def ai(aiCanvas, aob, pitch):
	pitchScaling = 1.3
	aiCanvas.configure(bg="#000000")

	# Blank
	aiTop = aiCanvas.create_rectangle(20, 20, 186, 186, fill="#000000")

	# Draw white arc, overlay blue circle, then brown arc
	aiTop = aiCanvas.create_arc(28, 28, 178, 178, start=0, extent=180, style=tk.CHORD, fill="#FFFFFF")
	aiTop = aiCanvas.create_oval(30, 30, 176, 176, fill="#0000FF")
	aiTop = aiCanvas.create_arc(30, 30, 176, 176, start=180 + aob + (pitchScaling * pitch), extent=180 - (pitchScaling * 2 * pitch), style=tk.CHORD, fill="#663300")

	# Pitch up/down lines
	if pitch >= -30:
        	pitchLine = 5
        	vertOrigin = 103 - (pitchLine * 1.2 * pitchScaling) + (pitchScaling * 1.25 * pitch)
        	aiCanvas.create_line(93, vertOrigin, 113, vertOrigin, width=2, fill="#FFFFFF")
	if pitch >= -25:
        	pitchLine = 10
        	vertOrigin = 103 - (pitchLine * 1.2 * pitchScaling) + (pitchScaling * 1.25 * pitch)
        	aiCanvas.create_line(83, vertOrigin, 123, vertOrigin, width=2, fill="#FFFFFF")
		aiCanvas.create_text(73, vertOrigin, fill="#FFFFFF", font=tkFont.Font(size=6), text="10")
		aiCanvas.create_text(133, vertOrigin, fill="#FFFFFF", font=tkFont.Font(size=6), text="10")
	if pitch >= -20:
        	pitchLine = 15
        	vertOrigin = 103 - (pitchLine * 1.2 * pitchScaling) + (pitchScaling * 1.25 * pitch)
        	aiCanvas.create_line(93, vertOrigin, 113, vertOrigin, width=2, fill="#FFFFFF")
	if pitch >= -15:
        	pitchLine = 20
        	vertOrigin = 103 - (pitchLine * 1.2 * pitchScaling) + (pitchScaling * 1.25 * pitch)
        	aiCanvas.create_line(73, vertOrigin, 133, vertOrigin, width=2, fill="#FFFFFF")
		aiCanvas.create_text(63, vertOrigin, fill="#FFFFFF", font=tkFont.Font(size=6), text="20")
		aiCanvas.create_text(143, vertOrigin, fill="#FFFFFF", font=tkFont.Font(size=6), text="20")
	if pitch <= 30:
        	pitchLine = -5
        	vertOrigin = 103 - (pitchLine * 1.2 * pitchScaling) + (pitchScaling * 1.25 * pitch)
        	aiCanvas.create_line(93, vertOrigin, 113, vertOrigin, width=2, fill="#FFFFFF")
	if pitch <= 25:
        	pitchLine = -10
        	vertOrigin = 103 - (pitchLine * 1.2 * pitchScaling) + (pitchScaling * 1.25 * pitch)
        	aiCanvas.create_line(83, vertOrigin, 123, vertOrigin, width=2, fill="#FFFFFF")
		aiCanvas.create_text(73, vertOrigin, fill="#FFFFFF", font=tkFont.Font(size=6), text="10")
		aiCanvas.create_text(133, vertOrigin, fill="#FFFFFF", font=tkFont.Font(size=6), text="10")
	if pitch <= 20:
        	pitchLine = -15
        	vertOrigin = 103 - (pitchLine * 1.2 * pitchScaling) + (pitchScaling * 1.25 * pitch)
        	aiCanvas.create_line(93, vertOrigin, 113, vertOrigin, width=2, fill="#FFFFFF")
	if pitch <= 15:
        	pitchLine = -20
        	vertOrigin = 103 - (pitchLine * 1.2 * pitchScaling) + (pitchScaling * 1.25 * pitch)
        	aiCanvas.create_line(73, vertOrigin, 133, vertOrigin, width=2, fill="#FFFFFF")
		aiCanvas.create_text(63, vertOrigin, fill="#FFFFFF", font=tkFont.Font(size=6), text="20")
		aiCanvas.create_text(143, vertOrigin, fill="#FFFFFF", font=tkFont.Font(size=6), text="20")

	# Aitcraft wings
	aiCanvas.create_line(50, 103, 90, 103, 90, 111, width=3, fill="#FF9900")
	aiCanvas.create_line(101, 103, 105, 103, width=5, fill="#FF9900")
	aiCanvas.create_line(116, 111, 116, 103, 156, 103, width=3, fill="#FF9900")

	# Add roll marks
	radius = 75
	markLen = 10
	startX = 103
	startY = 103 - radius
	aiCanvas.create_polygon(startX, startY, startX + 5, startY - 15, startX - 5, startY - 15, startX, startY, fill="#FFFFFF")
	roll = math.radians(45)
	startX = 103 + (math.sin(roll) * (radius + 5))
	startY = 103 - (math.cos(roll) * (radius + 5))
	aiCanvas.create_line(startX - 2, startY - 2, startX + 2, startY + 2, width=5, fill="#FFFFFF")
	roll = math.radians(-45)
	startX = 103 + (math.sin(roll) * (radius + 5))
	aiCanvas.create_line(startX - 2, startY - 2, startX + 2, startY + 2, width=5, fill="#FFFFFF")
        for roll in -20, -10, 10, 20:
		rollRad = math.radians(roll)
		startX = 103 + (math.sin(rollRad) * (radius + 3))
		startY = 103 - (math.cos(rollRad) * (radius + 3))
		aiCanvas.create_line(startX - 1, startY - 1, startX + 1, startY + 1, width=3, fill="#FFFFFF")
        for roll in -90, -60, -30, 30, 60, 90:
		rollRad = math.radians(roll)
		startX = 103 + (math.sin(rollRad) * radius)
		startY = 103 - (math.cos(rollRad) * radius)
		endX = 103 + (math.sin(rollRad) * (radius + markLen))
		endY = 103 - (math.cos(rollRad) * (radius + markLen))
		aiCanvas.create_line(startX, startY, endX, endY, width=2, fill="#FFFFFF")
	
	# Add yellow triangle
	rollRad = math.radians(aob)
	startX = 103 - (math.sin(rollRad) * radius)
	startY = 103 - (math.cos(rollRad) * radius)
	triAngle = math.radians(aob + 30)
 	x1 = startX + (math.sin(triAngle) * 15)
 	y1 = startY + (math.cos(triAngle) * 15)
	triAngle = math.radians(aob - 30)
 	x2 = startX + (math.sin(triAngle) * 15)
 	y2 = startY + (math.cos(triAngle) * 15)
	
	aiCanvas.create_polygon(startX, startY, x1, y1, x2, y2, startX, startY, fill="#FFFF00")


	aiCanvas.update()
# End def ai()

window = tk.Tk()
window.geometry("480x800")

tFrame = tk.Frame(master=window, width=470, height=400, relief=tk.GROOVE, borderwidth=5)
bFrame = tk.Frame(master=window, width=470, height=400, relief=tk.GROOVE, borderwidth=5)

tFrame.place(x=5, y=0)
bFrame.place(x=5, y=400)

aiCanvas = tk.Canvas(master=tFrame, width=200, height=200, relief=tk.RIDGE, borderwidth=5)
aiCanvas.configure(bg="#000000")
aiCanvas.place(x=123, y=80)

thrtCanvas = tk.Canvas(master=bFrame, width=300, height=300, relief=tk.RIDGE, borderwidth=5)
thrtCanvas.place(x=72, y=40)

window.update()

# Play with ai
ai(aiCanvas, -30, 0)
time.sleep(2)

ai(aiCanvas, 0, 0)
time.sleep(2)
ai(aiCanvas, 30, 0)
time.sleep(2)
ai(aiCanvas, 60, 0)
time.sleep(2)
ai(aiCanvas, 90, 0)
time.sleep(2)
ai(aiCanvas, 120, 0)
time.sleep(2)
ai(aiCanvas, 150, 0)
time.sleep(2)
ai(aiCanvas, 180, 0)
time.sleep(2)
ai(aiCanvas, 0, 30)
time.sleep(2)
ai(aiCanvas, 30, 30)
time.sleep(2)
ai(aiCanvas, 60, 30)
time.sleep(2)
ai(aiCanvas, 90, 30)
time.sleep(2)
ai(aiCanvas, 120, 30)
time.sleep(2)
ai(aiCanvas, 150, 30)
time.sleep(2)
ai(aiCanvas, 180, 30)
time.sleep(2)

ai(aiCanvas, 0, 0)
time.sleep(2)
ai(aiCanvas, 0, 5)
time.sleep(2)
ai(aiCanvas, 0, 10)
time.sleep(2)
ai(aiCanvas, 0, 15)
time.sleep(2)
ai(aiCanvas, 0, 20)
time.sleep(2)
ai(aiCanvas, 0, 25)
time.sleep(2)
ai(aiCanvas, 0, 0)
time.sleep(2)
ai(aiCanvas, 0, -5)
time.sleep(2)
ai(aiCanvas, 0, -10)
time.sleep(2)
ai(aiCanvas, 0, -15)
time.sleep(2)
ai(aiCanvas, 0, -20)
time.sleep(2)
ai(aiCanvas, 0, -25)
time.sleep(2)

ai(aiCanvas, 0, 0)
time.sleep(5)
ai(aiCanvas, 20, 0)
time.sleep(5)
ai(aiCanvas, 0, 15)
time.sleep(5)
ai(aiCanvas, 20, 15)
time.sleep(5)


#
#thrtCanvas = tk.Canvas(master=bFrame, width=300, height=300, relief=tk.RIDGE, borderwidth=5)
#thrtCanvas.place(x=72, y=40)

window.update()

time.sleep(30)
